// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from qb_softhand_industry_msgs:msg/DeviceConnectionInfo.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__FUNCTIONS_H_
#define QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "qb_softhand_industry_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "qb_softhand_industry_msgs/msg/detail/device_connection_info__struct.h"

/// Initialize msg/DeviceConnectionInfo message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo
 * )) before or use
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__init(qb_softhand_industry_msgs__msg__DeviceConnectionInfo * msg);

/// Finalize msg/DeviceConnectionInfo message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
void
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__fini(qb_softhand_industry_msgs__msg__DeviceConnectionInfo * msg);

/// Create msg/DeviceConnectionInfo message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
qb_softhand_industry_msgs__msg__DeviceConnectionInfo *
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__create();

/// Destroy msg/DeviceConnectionInfo message.
/**
 * It calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
void
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__destroy(qb_softhand_industry_msgs__msg__DeviceConnectionInfo * msg);

/// Check for msg/DeviceConnectionInfo message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__are_equal(const qb_softhand_industry_msgs__msg__DeviceConnectionInfo * lhs, const qb_softhand_industry_msgs__msg__DeviceConnectionInfo * rhs);

/// Copy a msg/DeviceConnectionInfo message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__copy(
  const qb_softhand_industry_msgs__msg__DeviceConnectionInfo * input,
  qb_softhand_industry_msgs__msg__DeviceConnectionInfo * output);

/// Initialize array of msg/DeviceConnectionInfo messages.
/**
 * It allocates the memory for the number of elements and calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__init(qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * array, size_t size);

/// Finalize array of msg/DeviceConnectionInfo messages.
/**
 * It calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
void
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__fini(qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * array);

/// Create array of msg/DeviceConnectionInfo messages.
/**
 * It allocates the memory for the array and calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence *
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__create(size_t size);

/// Destroy array of msg/DeviceConnectionInfo messages.
/**
 * It calls
 * qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
void
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__destroy(qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * array);

/// Check for msg/DeviceConnectionInfo message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__are_equal(const qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * lhs, const qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * rhs);

/// Copy an array of msg/DeviceConnectionInfo messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_msgs
bool
qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence__copy(
  const qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * input,
  qb_softhand_industry_msgs__msg__DeviceConnectionInfo__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__FUNCTIONS_H_
