// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_softhand_industry_msgs:msg/ResourceData.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__TRAITS_HPP_
#define QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_softhand_industry_msgs/msg/detail/resource_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_softhand_industry_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ResourceData & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    rosidl_generator_traits::value_to_yaml(msg.position, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: effort
  {
    out << "effort: ";
    rosidl_generator_traits::value_to_yaml(msg.effort, out);
    out << ", ";
  }

  // member: command
  {
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ResourceData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position: ";
    rosidl_generator_traits::value_to_yaml(msg.position, out);
    out << "\n";
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << "\n";
  }

  // member: effort
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "effort: ";
    rosidl_generator_traits::value_to_yaml(msg.effort, out);
    out << "\n";
  }

  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ResourceData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_softhand_industry_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_softhand_industry_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_softhand_industry_msgs::msg::ResourceData & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_softhand_industry_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_softhand_industry_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_softhand_industry_msgs::msg::ResourceData & msg)
{
  return qb_softhand_industry_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_softhand_industry_msgs::msg::ResourceData>()
{
  return "qb_softhand_industry_msgs::msg::ResourceData";
}

template<>
inline const char * name<qb_softhand_industry_msgs::msg::ResourceData>()
{
  return "qb_softhand_industry_msgs/msg/ResourceData";
}

template<>
struct has_fixed_size<qb_softhand_industry_msgs::msg::ResourceData>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_softhand_industry_msgs::msg::ResourceData>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_softhand_industry_msgs::msg::ResourceData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__RESOURCE_DATA__TRAITS_HPP_
